#import "TestView.h"
#import "PopUpMenu.h"
#import "PowerMenu.h"
#import <dpsclient/psops.h>
#import <appkit/Cell.h>
#import <appkit/color.h>

@implementation TestView



- initFrame:(const NXRect*)rect
{
  id p2, p3;
	[super initFrame: rect];


	// to create a menu, you don't have to give a tag or an action message

		menu = [[PopUpMenu alloc] initWithMenuString: " 
			[blah/selectionMade:/0]
			[file [
				[save/selectionMade:/2]
				[save as/selectionMade:/3]
				[close/selectionMade:/4]
				[open/selectionMade:/5]]]
			[power off/selectionMade:/6]
			[selection item/selectionMade:/7]
			[change/selectionMade:/8]
			[find [
				[class [
					[blah1 [
						[this/selectionMade:/9]
						[or [
							[please/selectionMade:/10]
							[help/selectionMade:/11]
							[my/selectionMade:/12]
							[fish/selectionMade:/13]]]
						[that/selectionMade:/14]]]
					[blah2/selectionMade:/15]]]
				[category/selectionMade:/16]]]
			[copy/selectionMade:/17]
			[new/selectionMade:/18]
			"];
		[menu setTarget: self];
	
	
  powermenu = [[PowerMenu alloc] init];
  [powermenu setDefaultTarget:self];
  [powermenu setDefaultAction:@selector(selectionMade:)];
	
  p2 = [[PowerMenu alloc] init];
  [p2 setDefaultTarget:self];
  [p2 setDefaultAction:@selector(selectionMade:)];
  [p2 addSelectionAt:0];
  [[[p2 selectionAt:0] setLabel:"saVe"] setTag: 100];
  [p2 addSelectionAt:1];
  [[[p2 selectionAt:1] setLabel:"cloSe"] setTag: 101];
  [p2 addSelectionAt:2];
  [[[p2 selectionAt:2] setLabel:"oPen"] setTag: 102];
  [p2 addSelectionAt:3];
  [[[p2 selectionAt:3] setLabel:"save as"] setTag: 103];

  p3 = [[PowerMenu alloc] init];
  [p3 setDefaultTarget:self];
  [p3 setDefaultAction:@selector(selectionMade:)];
  [p3 addSelectionAt:0];
  [[[p3 selectionAt:0] setLabel:"please"] setTag: 200];
  [p3 addSelectionAt:1];
  [[[p3 selectionAt:1] setLabel:"HelP"] setTag: 201];
  [p3 addSelectionAt:2];
  [[[p3 selectionAt:2] setLabel:"my"] setTag: 202];
  [p3 addSelectionAt:3];
  [[[p3 selectionAt:3] setLabel:"fish"] setTag: 203];
  [p2 addSubmenu:p3 toSelection:2];

  [powermenu addSelectionAt:0];
  [[[powermenu selectionAt:0] setLabel:"blAh"] setTag:0]; 
  [powermenu addSelectionAt:1];
  [[[powermenu selectionAt:1] setLabel:"fiLe"] setTag:1]; 
  [powermenu addSubmenu:p2 toSelection:1];
  
  [powermenu addSelectionAt:2];
  [[[[powermenu selectionAt:2] setLabel:"Miscellaneous"] setTag:2] titleOnly];

  [powermenu addSelectionAt:3];
  [[[[powermenu selectionAt:3] setLabel:"Miscellaneous"] setTag:3] separator];
  
  [powermenu addSelectionAt:4];
  [[[powermenu selectionAt:4] setLabel:"Power off"] setTag:4];
  [powermenu addSelectionAt:5];
  [[[powermenu selectionAt:5] setLabel:"selection Item"] setTag:5];
  [powermenu addSelectionAt:6];
  [[[powermenu selectionAt:6] setLabel:"fiNd"] setTag:6];

  [powermenu dump];
  
  return self;
}



- rightMouseDown:(NXEvent*) event
{
	//[menu popUp: self];
  [powermenu popUp:self];
	return self;
}



- selectionMade: cell
{
	// to get the tag, use [cell tag]
	[textfield setStringValue: [cell title]];
	return self;
}




- drawSelf: (const NXRect*) rect :(int) numRects
{
	NXSetColor(NX_COLORBLUE);
	NXRectFill(&rect[0]);
	return self;
}


@end
